﻿package  {
	import flash.display.Sprite;
	import flash.events.Event;
	
	public class MovingRectangle extends Sprite
	{
		private var canvas:Sprite=new Sprite();
		private var quantity:Number=int(Math.random()*4)+3;
		private var rect:Array = [];
		private var rectNum:Number=0;
		
		private var hauteur:Number=768/quantity;
		
		private var compteur:Number=0;
		
		private var couleurBase:uint=Math.random()*0xffffff;
		
		public function MovingRectangle() {
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			canvas.graphics.beginFill(couleurBase,(Math.random()*5+2)/10);
			canvas.graphics.drawRect(0,0,600,600);
			addChild (canvas);
			var hauteur:Number=600/quantity;
			
			for(var i:Number = 0;i<quantity;i++){
				var separation:Number=(Math.random()*(600-35-35)+35);
				var vitesseW:Number=Math.random()*8+2;
				var vitesseH:Number=Math.random()*2+1;
				var sens:Number=int(Math.random()*2) - 1 | 1;
				var sens2:Number=int(Math.random()*2) - 1 | 1;
				var color:uint=Math.random()*couleurBase;
				var epaisseur:Number=int(Math.random()*4)+3;
				
				for (var j:Number = 0;j<2;j++){
					addRect(0,hauteur*i,separation,j,i,vitesseW,vitesseH,sens,sens2,color,epaisseur);
				}
			}
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		
		private function addRect (x1:Number,y1:Number,_separation:Number,gd:Number,gd2:Number,_vitesseW:Number,_vitesseH:Number,_sens:Number,_sens2:Number,_color:uint,_epaisseur:Number):void
		{
			rect[rectNum] = new Object();
			rect[rectNum]._gd = gd;
			rect[rectNum]._gd2 = gd2;
			rect[rectNum]._vitesseW = _vitesseW;
			rect[rectNum]._vitesseH = _vitesseH;
			rect[rectNum]._sens = _sens;
			rect[rectNum]._sens2 = _sens2;
			rect[rectNum]._epaisseur = _epaisseur;
			rect[rectNum].s = new Sprite();
			rect[rectNum].s.graphics.beginFill(_color,1);
			rect[rectNum].s.graphics.drawRect(0,0,_separation,hauteur);
			rect[rectNum].s.graphics.drawRect(_epaisseur*1.2,_epaisseur,_separation - _epaisseur*2 , hauteur - _epaisseur*2);
			rect[rectNum].s.graphics.endFill();
			
			if (gd!=0){
				rect[rectNum].s.x=rect[rectNum-1].s.width-5;
			}
			
			addChild(rect[rectNum].s);
			rectNum++;
		}
		
		private function enterHandler(e:Event):void
		{
			movedot();
		}
		
		private function movedot():void
		{
			var i:Number;
			var gdx:Number;
			compteur+=1/10;
			
			for(i = 0;i<rectNum;i++){
				
				if (rect[i]._gd==0){
					rect[i].s.x = 0;
					rect[i].s.width += rect[i]._sens*Math.cos(compteur)*rect[i]._vitesseW;
				}else{
					rect[i].s.x = rect[i-1].s.width-5;
					rect[i].s.width = 600-rect[i-1].s.width;
				}
				
				if (rect[i]._gd2 > 0){
					if (rect[i]._gd==0){
						rect[i].s.y = rect[i-2].s.height+rect[i-2].s.y;
					}else{
						rect[i].s.y = rect[i-1].s.y;
					}
				}
				
				if (rect[i]._gd2 < quantity-1){
					rect[i].s.height += rect[i]._sens*Math.cos(compteur)*rect[i]._vitesseH;
				}
				
				if (rect[i]._gd2 == quantity-1){
					if (rect[i]._gd==0){
						rect[i].s.height = 600-rect[i].s.y;
					}else{
						rect[i].s.height = rect[i-1].s.height;
					}
				}
			}
		}
	}
	
}
